#include <iostream>

using namespace std;

class AbstrakcyjnaWtyczkaPL
{
public:
	virtual void bolceOkrge() = 0;
	virtual void liczbaBolcw() = 0;
};

class WtyczkaPL : public AbstrakcyjnaWtyczkaPL
{
public:
	void bolceOkrge()
	{
		cout << "Mamy bolce okrge" << endl;
	}

	void liczbaBolcw()
	{
		cout << "Mamy 2 bolce" << endl;
	}
};

class AbstrakcyjneGniazdoUK
{
public:
	virtual void bolcePaskie() = 0;
	virtual void liczbaBolcw() = 0;
};

class GniazdoUK : public AbstrakcyjneGniazdoUK
{
public:
	void bolcePaskie()
	{
		cout << "Przyjmiemy bolce paskie" << endl;
	}

	void liczbaBolcw()
	{
		cout << "Przyjmiemy 3 bolce" << endl;
	}
};

//udaje e jest wtyczk PL dla gniazdka, a gniazdko UK dla wtyczki
class AdapterWtyczkiPLdoGniazdaUK : public AbstrakcyjnaWtyczkaPL
{
public:
	AbstrakcyjneGniazdoUK* abstrakcyjneGniazdoUK;
	AdapterWtyczkiPLdoGniazdaUK(AbstrakcyjneGniazdoUK* gniazdoUK)
	{
		this->abstrakcyjneGniazdoUK = gniazdoUK;
	}

	void bolceOkrge()
	{
		abstrakcyjneGniazdoUK->bolcePaskie();
	}
	void liczbaBolcw()
	{
		abstrakcyjneGniazdoUK->liczbaBolcw();
	}
};

int main_adapter()
{
	GniazdoUK* gniazdkoUK = new GniazdoUK();
	AbstrakcyjnaWtyczkaPL* adapter = new AdapterWtyczkiPLdoGniazdaUK(gniazdkoUK);
	adapter->bolceOkrge();
	adapter->liczbaBolcw();

	return 0;
}