#include <iostream>
#include <string>

using namespace std;

//Fasada integruje

class Telewizor
{
public:
	void wcz()
	{
		cout << "Telewizor zosta wczony" << endl;
	}
	void wycz()
	{
		cout << "Telewizor zosta wyczony" << endl;
	}
};

class OdtwarzaczDVD
{
public:
	void wcz()
	{
		cout << "Odtwarzacz DVD zosta wczony" << endl;
	}
	void wycz()
	{
		cout << "Odtwarzacz DVD zosta wyczony" << endl;
	}
	void odtwarzaj(string tytu)
	{
		cout << "Odtwarzanie filmu \"" << tytu << "\" zostao rozpoczte" << endl;
	}
};

class Owietlenie
{
public:
	void wcz()
	{
		cout << "Owietlenie zostao wczone" << endl;
	}
	void wycz()
	{
		cout << "Owietlenie zostao wyczone" << endl;
	}
};

class Fasada_KinoDomowe
{
private:
	Telewizor* tv;
	OdtwarzaczDVD* dvd;
	Owietlenie* owietlenie;
public:
	Fasada_KinoDomowe(Telewizor* tv,OdtwarzaczDVD* dvd,Owietlenie* owietlenie)
	{
		this->tv = tv;
		this->dvd = dvd;
		this->owietlenie = owietlenie;
	}
	void wczOdtwarzanieFilmu(string tytu)
	{
		tv->wcz();
		dvd->wcz();
		owietlenie->wycz();
		dvd->odtwarzaj(tytu);
	}
};

int main_fasada()
{
	Fasada_KinoDomowe kinoDomowe(new Telewizor(), new OdtwarzaczDVD(), new Owietlenie());
	kinoDomowe.wczOdtwarzanieFilmu("Kevin sam w domu");

	return 0;
}